unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ScktComp, StdCtrls, IdBaseComponent, IdComponent,
  IdIPWatch;

//
Const
  IOC_IN = $80000000;
  IOC_VENDOR = $18000000;
  IOC_out = $40000000;
  SIO_KEEPALIVE_VALS = IOC_IN or IOC_VENDOR or 4;
  DATA_BUFSIZE = 8192;

// KeepAlive ݽṹ
Type
  TTCP_KEEPALIVE = packed record
    onoff: integer;
    keepalivetime: integer;
    keepaliveinterval: integer;
  end;

type
  TForm1 = class(TForm)
    ClientSocket1: TClientSocket;
    lbledt_ip: TLabeledEdit;
    lbledt_port: TLabeledEdit;
    lbledt_content: TLabeledEdit;
    btnConnect: TButton;
    btnDisconnect: TButton;
    btnSend: TButton;
    Label2: TLabel;
    Memo1: TMemo;
    btnClear: TButton;
    IdIPWatch1: TIdIPWatch;
    lbledt_localIP: TLabeledEdit;
    Timer_connect: TTimer;
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure FormCreate(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure btnConnectClick(Sender: TObject);
    procedure Timer_connectTimer(Sender: TObject);
    procedure btnDisconnectClick(Sender: TObject);
    procedure btnSendClick(Sender: TObject);
    procedure ClientSocket1Connecting(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Lookup(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Write(Sender: TObject;
      Socket: TCustomWinSocket);
  private
    { Private declarations }
    procedure setInitFlag(flag: Boolean);   
    procedure showInfo(info: string);
    procedure connectServer();
  public
    { Public declarations }
    procedure setKeepAlive(Socket: TCustomWinSocket);
    //socket
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses
  WinSock,WinSock2;
procedure TForm1.ClientSocket1Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  showInfo('ClientSocket1Disconnect--' + Socket.RemoteAddress + ':' + IntToStr(Socket.RemotePort));
  showInfo('' + lbledt_ip.Text + ':' + lbledt_port.Text + 'жϣʼ');
  Timer_connect.Enabled := True;
  setInitFlag(False);
end;

procedure TForm1.ClientSocket1Error(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  showInfo('ClientSocket1Error--' + Socket.RemoteAddress + ':' + IntToStr(Socket.RemotePort));
  ErrorCode := 0;
  Socket.Close;
end;

procedure TForm1.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
var
  tmpstr,UserIP, MachineName:string;
begin
  showInfo('ClientSocket1Connect' + lbledt_ip.Text + ':' + lbledt_port.Text + 'ɹ');
  Timer_connect.Enabled := False;
  setInitFlag(True); 
  setKeepAlive(Socket);//socket

end;


procedure TForm1.setInitFlag(flag: Boolean);
begin
  if flag  then//
  begin
    btnConnect.Enabled := False;
    btnDisconnect.Enabled := True;
    btnSend.Enabled := True;
  end
  else//δ
  begin
    btnConnect.Enabled := True;
    btnDisconnect.Enabled := False;
    btnSend.Enabled := False;
  end;
end;

procedure TForm1.showInfo(info: string);
begin
  if Memo1.Lines.Count > 300 then
    Memo1.Lines.Clear; 
  Memo1.Lines.Add('' + FormatDateTime('yyyy-mm-dd hh:mm:ss',Now) + '' + info);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  setInitFlag(False);
  btnClearClick(Self);
  lbledt_localIP.Text := IdIPWatch1.LocalIP;
end;

procedure TForm1.btnClearClick(Sender: TObject);
begin
  Memo1.Clear;
end;

procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  showInfo('ClientSocket1Read--' + Socket.RemoteAddress + ':' + IntToStr(Socket.RemotePort));
  showInfo('յ' + Socket.ReceiveText);
  
end;

procedure TForm1.btnConnectClick(Sender: TObject);
begin
  connectServer();
end;

procedure TForm1.connectServer;
begin
  ClientSocket1.Host := lbledt_ip.Text;
  ClientSocket1.Port := StrToInt(lbledt_port.Text);
  if not ClientSocket1.Active then
    ClientSocket1.Open;
end;

procedure TForm1.Timer_connectTimer(Sender: TObject);
begin
  Timer_connect.Enabled := False;
  connectServer;
end;

procedure TForm1.btnDisconnectClick(Sender: TObject);
begin
  ClientSocket1.Close;
end;

procedure TForm1.btnSendClick(Sender: TObject);
begin
  ClientSocket1.Socket.SendText(lbledt_content.Text);
end;

procedure TForm1.setKeepAlive(Socket: TCustomWinSocket);
var
  opt:Integer;
  klive, outKlive: TTCP_KEEPALIVE;  
begin
  opt := 1;
  //WinSock.pas
  if setsockopt(Socket.SocketHandle,SOL_SOCKET, SO_KEEPALIVE, PAnsiChar(@opt), SizeOf(opt)) = SOCKET_ERROR then
  begin
    showInfo(Format('WinSock Error %d', [WSAGetLastError()]));
  end;
  klive.onoff := 1;
  klive.keepalivetime := 3000;
  klive.keepaliveinterval := 1;
  //WinSock2.pas
  if WSAIoctl(Socket.SocketHandle, SIO_KEEPALIVE_VALS, PAnsiChar(@klive),
           SizeOf(TTCP_KEEPALIVE), PAnsiChar(@outKlive),
           SizeOf(TTCP_KEEPALIVE), @opt,0,nil) = SOCKET_ERROR then
  begin
    showInfo(Format('WinSock Error %d', [WSAGetLastError()]));
  end;

end;

procedure TForm1.ClientSocket1Connecting(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  showInfo('ClientSocket1Connecting--' + Socket.RemoteAddress + ':' + IntToStr(Socket.RemotePort));
end;

procedure TForm1.ClientSocket1Lookup(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  showInfo('ClientSocket1Lookup--' + Socket.RemoteAddress + ':' + IntToStr(Socket.RemotePort));
end;

procedure TForm1.ClientSocket1Write(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  showInfo('ClientSocket1Write--' + Socket.RemoteAddress + ':' + IntToStr(Socket.RemotePort));
end;

end.
