unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ScktComp,WinSock,WinSock2, Grids;


//
Const
  IOC_IN = $80000000;
  IOC_VENDOR = $18000000;
  IOC_out = $40000000;
  SIO_KEEPALIVE_VALS = IOC_IN or IOC_VENDOR or 4;
  DATA_BUFSIZE = 8192;

// KeepAlive ݽṹ
Type
  TTCP_KEEPALIVE = packed record
    onoff: integer;
    keepalivetime: integer;
    keepaliveinterval: integer;
  end;


type
  client_record=record
     CHandle: integer;            { ͻ׽־  }
     CSocket:TCustomWinSocket;    { ͻ׽      }
     CAddress:string;             { ͻ˼IPַ}
     CPort: Integer;             { ͻ˼Ӷ˿}
     CUsed: boolean;              { ͻ־    }
  end;

type
  TForm1 = class(TForm)
    btnStart: TButton;
    ServerSocket1: TServerSocket;
    lbledt_Port: TLabeledEdit;
    btnStop: TButton;
    StringGrid1: TStringGrid;
    Label1: TLabel;
    Memo1: TMemo;
    btnClear: TButton;
    lbl1: TLabel;
    procedure btnStartClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure ServerSocket1ClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientWrite(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1GetSocket(Sender: TObject; Socket: Integer;
      var ClientSocket: TServerClientWinSocket);
    procedure ServerSocket1GetThread(Sender: TObject;
      ClientSocket: TServerClientWinSocket;
      var SocketThread: TServerClientThread);
    procedure ServerSocket1Listen(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ThreadEnd(Sender: TObject;
      Thread: TServerClientThread);
    procedure ServerSocket1ThreadStart(Sender: TObject;
      Thread: TServerClientThread);
    procedure ServerSocket1ClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1Accept(Sender: TObject;
      Socket: TCustomWinSocket);
  private
    { Private declarations }
    { ڱͻϢ }
    session: array[0.. 5000 ] of client_record;

  public
    { Public declarations }
    Sessions: Integer;

    procedure setInitFlag(flag: Boolean);
    procedure initGrid();
    procedure showInfo(info: string);
    procedure QueryConnect;
    //ˢµǰӿͻ
    procedure setKeepAlive(Socket: TCustomWinSocket);
    //socket
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ TForm1 }

procedure TForm1.btnStartClick(Sender: TObject);
begin
  try
    ServerSocket1.Port := StrToInt(lbledt_Port.Text);
//    ServerSocket1.OnClientConnect := ClientConnect;
    ServerSocket1.Open;
    setInitFlag(True);
    showInfo('򿪶˿' + lbledt_Port.Text + 'ɹ');
  except
    setInitFlag(False);
    showInfo('򿪶˿' + lbledt_Port.Text + 'ʧܣ');
  end;

end;

procedure TForm1.setInitFlag(flag: Boolean);
begin
  if flag  then
  begin
    btnStart.Enabled := False;
    btnStop.Enabled := True;
  end
  else
  begin
    btnStart.Enabled := True;
    btnStop.Enabled := False;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  setInitFlag(False);
  initGrid;
  btnClearClick(Self);
end;

procedure TForm1.btnStopClick(Sender: TObject);
begin
  ServerSocket1.Close;
  setInitFlag(False);
end;



procedure TForm1.btnClearClick(Sender: TObject);
begin
  Memo1.Clear;
end;

procedure TForm1.showInfo(info: string);
begin
  if Memo1.Lines.Count > 300 then
    Memo1.Lines.Clear;

  Memo1.Lines.Add('' + FormatDateTime('yyyy-mm-dd hh:mm:ss',Now) + '' + info);
end;

procedure TForm1.ServerSocket1ClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  showInfo('ServerSocket1ClientError-' + Socket.RemoteAddress + ':' + IntToStr(Socket.RemotePort));
  ErrorCode := 0;
  Socket.Close;
  QueryConnect; //ˢµǰӿͻ
end;

procedure TForm1.ServerSocket1ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  showInfo('ServerSocket1ClientRead--' + Socket.ReceiveText  + '      -' + Socket.RemoteAddress + ':' + IntToStr(Socket.RemotePort));
  Socket.SendText('server reply!')
end;

procedure TForm1.ServerSocket1ClientWrite(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  showInfo('ServerSocket1ClientWrite-' + Socket.RemoteAddress + ':' + IntToStr(Socket.RemotePort));
end;

procedure TForm1.ServerSocket1GetSocket(Sender: TObject; Socket: Integer;
  var ClientSocket: TServerClientWinSocket);
begin
  showInfo('ServerSocket1GetSocket-');
end;

procedure TForm1.ServerSocket1GetThread(Sender: TObject;
  ClientSocket: TServerClientWinSocket;
  var SocketThread: TServerClientThread);
begin
  showInfo('ServerSocket1GetThread-');
end;

procedure TForm1.ServerSocket1Listen(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  showInfo('ServerSocket1Listen-' + Socket.RemoteAddress + ':' + IntToStr(Socket.RemotePort));
end;

procedure TForm1.ServerSocket1ThreadEnd(Sender: TObject;
  Thread: TServerClientThread);
begin
  showInfo('ServerSocket1ThreadEnd-' );
end;

procedure TForm1.ServerSocket1ThreadStart(Sender: TObject;
  Thread: TServerClientThread);
begin
  showInfo('ServerSocket1ThreadStart-');
end;

procedure TForm1.ServerSocket1ClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
  i:integer;
begin
  showInfo('ServerSocket1ClientDisconnect-' + Socket.RemoteAddress + ':' + IntToStr(Socket.RemotePort));
  for i:=0 to sessions do
  begin
    if session[i].CHandle =Socket.SocketHandle then
    begin
      session[i].CHandle :=0;
      session[i].CUsed := False;
      Break;
    end;
  end;

  QueryConnect;  //ˢµǰӿͻ
end;

procedure TForm1.ServerSocket1ClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
  i,j:integer;
begin
  showInfo('ServerSocket1ClientConnect-' + Socket.RemoteAddress + ':' + IntToStr(Socket.RemotePort));
  setKeepAlive(Socket); //socketԱ


    { ҳԭеĿͻжϵĿͻ, µĿͻ }
  for i:=0 to sessions do
  begin
    if not session[i].CUsed then
    begin
      session[i].CHandle := Socket.SocketHandle ;  //ͻ׽־
      session[i].CSocket := Socket;                //ͻ׽
      session[i].CAddress := Socket.RemoteAddress ;//ͻ˼IP
      session[i].CPort := Socket.RemotePort ;      //ͻ˼˿ں
      session[i].CUsed := True;                    //鵱ǰλѾռ
      Break;
    end;
  end;
  { Ԥһλڴһͻ }
  if sessions = 0 then
     inc(sessions);
    { ûб̿,ִ´,Ҳ }
  if i > sessions then
  begin
    inc(sessions);
    session[i].CHandle := Socket.SocketHandle ;  //ͻ׽־
    session[i].CSocket := Socket;                //ͻ׽
    session[i].CAddress := Socket.RemoteAddress ;//ͻ˼IP
    session[i].CPort := Socket.RemotePort ;
    session[i].CUsed := True;                    //鵱ǰλѾռ
  end;

  QueryConnect; //ˢµǰӿͻ
end;












procedure TForm1.ServerSocket1Accept(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  showInfo('ServerSocket1Accept-' + Socket.RemoteAddress + ':' + IntToStr(Socket.RemotePort));
end;

procedure TForm1.QueryConnect;
var
  id,i,call_used_count: Integer;
  tmp_doctor_id,doctor_name,connect_type: string;
begin
  for i := 1 to StringGrid1.RowCount - 1 do
    StringGrid1.Rows[i].Clear;
  StringGrid1.RowCount := 2;
  id := 1;
  call_used_count := 0;//Ѿʹõк

  for i := 0 to Sessions do
  begin
    if session[i].CUsed then
    begin
      StringGrid1.Cells[0, StringGrid1.RowCount-1] := inttostr(id);
      StringGrid1.Cells[1, StringGrid1.RowCount-1] := session[i].CAddress;
      StringGrid1.Cells[2, StringGrid1.RowCount-1] := IntToStr(session[i].CPort);
      id := id + 1;
      StringGrid1.RowCount := StringGrid1.RowCount + 1 ;
    end;
  end;
  if id > 1 then
  begin
    id := id - 1;
    StringGrid1.RowCount := StringGrid1.RowCount - 1 ;
  end;   
end;

procedure TForm1.initGrid;
begin
  StringGrid1.RowCount := 2;
  StringGrid1.ColCount := 3;
  StringGrid1.FixedRows := 1;
  StringGrid1.FixedCols := 0;
  StringGrid1.ScrollBars := ssVertical;
  StringGrid1.Options := StringGrid1.Options - [goEditing] - [goRowSizing] - [goColSizing] + [goRowSelect];

  StringGrid1.Cells[0, 0] := '';
  StringGrid1.ColWidths[0] := 100;
  StringGrid1.Cells[1, 0] := 'IPַ';
  StringGrid1.ColWidths[1] := 310;
  StringGrid1.Cells[2, 0] := '˿ں';
  StringGrid1.ColWidths[2] := 120;
//  StringGrid1.Cells[3, 0] := 'ͻ˱';
//  StringGrid1.ColWidths[3] := 190;

  StringGrid1.Cells[0, 1] := '';
  StringGrid1.Cells[1, 1] := '';
  StringGrid1.Cells[2, 1] := '';
//  StringGrid1.Cells[3, 1] := '';
end;


procedure TForm1.setKeepAlive(Socket: TCustomWinSocket);
var
  opt:Integer;
  klive, outKlive: TTCP_KEEPALIVE;
  i,j:integer;
  OptVal: DWORD;
begin
  opt := 1;
  //WinSock.pas
  if setsockopt(Socket.SocketHandle,SOL_SOCKET, SO_KEEPALIVE, PAnsiChar(@opt), SizeOf(opt)) = SOCKET_ERROR then
  begin
    showInfo(Format('WinSock Error %d', [WSAGetLastError()]));
  end;
  klive.onoff := 1;
  klive.keepalivetime := 5000;
  klive.keepaliveinterval := 1;
  //WinSock2.pas
  if WSAIoctl(Socket.SocketHandle, SIO_KEEPALIVE_VALS, PAnsiChar(@klive),
           SizeOf(TTCP_KEEPALIVE), PAnsiChar(@outKlive),
           SizeOf(TTCP_KEEPALIVE), @opt,0,nil) = SOCKET_ERROR then
  begin
    showInfo(Format('WinSock Error %d', [WSAGetLastError()]));
  end;

end;

end.
